#ifndef EFL_MODEL_CONTAINER_EO_HH
#define EFL_MODEL_CONTAINER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_loop.eo.h"
#include "efl_loop_consumer.eo.h"
#include "efl_model.eo.h"
#include "efl_model_container.eo.h"
#include "efl_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_loop.eo.hh"
#include "efl_loop_consumer.eo.hh"
#include "efl_model.eo.hh"
#include "efl_object.eo.hh"
#ifndef EFL_MODEL_CONTAINER_FWD_GUARD
#define EFL_MODEL_CONTAINER_FWD_GUARD
namespace efl { 
struct Model_Container;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Model_Container> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Model_Container&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Model_Container const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Model_Container const&> : ::std::true_type {}; } }
#endif
#ifndef EFL_LOOP_FWD_GUARD
#define EFL_LOOP_FWD_GUARD
namespace efl { 
struct Loop;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Loop> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Loop&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Loop const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Loop const&> : ::std::true_type {}; } }
#endif
#ifndef EFL_LOOP_CONSUMER_FWD_GUARD
#define EFL_LOOP_CONSUMER_FWD_GUARD
namespace efl { 
struct Loop_Consumer;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Loop_Consumer> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Loop_Consumer&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Loop_Consumer const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Loop_Consumer const&> : ::std::true_type {}; } }
#endif
#ifndef EFL_MODEL_FWD_GUARD
#define EFL_MODEL_FWD_GUARD
namespace efl { 
struct Model;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Model> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Model&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Model const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Model const&> : ::std::true_type {}; } }
#endif
#ifndef EFL_OBJECT_FWD_GUARD
#define EFL_OBJECT_FWD_GUARD
namespace efl { 
struct Object;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { 
struct Model_Container {
   ::efl::eolian::return_traits<Eina_Value_Type const&>::type child_property_value_type_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator<void*>>::type child_property_values_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   ::efl::eolian::return_traits<bool>::type child_property_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name,  ::efl::eolian::in_traits<Eina_Value_Type const&>::type type,  ::efl::eolian::in_traits< ::efl::eina::iterator<void const*>>::type values) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_MODEL_CONTAINER_CLASS;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Model_Container *>(this))); }
   operator ::efl::Model_Container() const;
   operator ::efl::Model_Container&();
   operator ::efl::Model_Container const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Model_Container,  ::efl::Loop_Consumer,  ::efl::Model,  ::efl::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Model_Container const ,  ::efl::Loop_Consumer const ,  ::efl::Model const ,  ::efl::Object const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Model_Container : private ::efl::eo::concrete
   , EO_CXX_INHERIT(::efl::Loop_Consumer)
   , EO_CXX_INHERIT(::efl::Model)
   , EO_CXX_INHERIT(::efl::Object)
{
   explicit Model_Container( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Model_Container(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Model_Container() = default;
   Model_Container(Model_Container const&) = default;
   Model_Container(Model_Container&&) = default;
   Model_Container& operator=(Model_Container const&) = default;
   Model_Container& operator=(Model_Container&&) = default;
   template <typename Derived>
   Model_Container(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Model_Container, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

   Model_Container( ::efl::eo::instantiate_t)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   template <typename T>
   explicit Model_Container( ::efl::eo::instantiate_t, T&& parent, typename std::enable_if< ::efl::eo::is_eolian_object<T>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Model_Container( ::efl::eo::instantiate_t, F&& f, typename ::std::enable_if< ::efl::eolian::is_constructor_lambda<F, Model_Container >::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), *this, std::forward<F>(f));
   }
   template <typename T, typename F> Model_Container(  ::efl::eo::instantiate_t, T&& parent, F&& f, typename ::std::enable_if< ::efl::eolian::is_constructor_lambda<F, Model_Container >::value && ::efl::eo::is_eolian_object<T>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class(), *this, std::forward<F>(f));
   }

   ::efl::eolian::return_traits<Eina_Value_Type const&>::type child_property_value_type_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator<void*>>::type child_property_values_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   ::efl::eolian::return_traits<bool>::type child_property_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name,  ::efl::eolian::in_traits<Eina_Value_Type const&>::type type,  ::efl::eolian::in_traits< ::efl::eina::iterator<void const*>>::type values) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_MODEL_CONTAINER_CLASS;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Model_Container *>(this))); }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Model_Container,  ::efl::Loop_Consumer,  ::efl::Model,  ::efl::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Model_Container const ,  ::efl::Loop_Consumer const ,  ::efl::Model const ,  ::efl::Object const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Model_Container> _get_wref() const { return ::efl::eo::wref<Model_Container>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Model_Container* operator->() const { return this; }
   Model_Container* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Model_Container const& lhs, Model_Container const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Model_Container const& lhs, Model_Container const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Model_Container) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Model_Container>::value, "");
} 
#endif
